module stage0	(reset, preq, nreq, in1, in2, in3, in4, out1, out2, out3, out4);
	input reset;
	input preq;
	output nreq;
	input [31:0] in1, in2, in3, in4;
	output [31:0] out1, out2, out3, out4;
	
	wire lclk0;
	wire wd_x_out;
	wire wd_y_out;
	wire wd_u_out;
	wire wd_dx_out;

	ctrl0			ctrl0		(.reset(reset), .preq(preq), .nreq(nreq), .lclk(lclk0));
	wd_x			wd_x		(.in(lclk0), .out(wd_x_out));
	wd_y			wd_y		(.in(lclk0), .out(wd_y_out));
	wd_u			wd_u		(.in(lclk0), .out(wd_u_out));
	wd_dx			wd_dx		(.in(lclk0), .out(wd_dx_out));	
	dff32a 		x  		(.in(in1), .reset(reset), .clock(wd_x_out), .out(out1));
	dff32a 		y  		(.in(in2), .reset(reset), .clock(wd_y_out), .out(out2));
	dff32a 		u  		(.in(in3), .reset(reset), .clock(wd_u_out), .out(out3));
	dff32a 		dx 		(.in(in4), .reset(reset), .clock(wd_dx_out), .out(out4));

endmodule
