module	stage1	(reset, preq, nreq, in1, in2, in3, in4, out1, out2, out3, out4, out5, out6, out7);
	input reset;
	input preq;
	output nreq;
	input		[31:0] in1, in2, in3, in4;
	output	[31:0] out1, out2, out3, out4, out5, out6, out7;

	wire lclk1;
	wire wd_st1_y_out;
	wire wd_st1_u_out;
	wire wd_st1_dx_out;
	wire wd_add0_reg_out;
	wire wd_mul0_reg_out;
	wire wd_mul1_reg_out;	
	wire wd_mul2_reg_out;
	wire [31:0] add0_out, mul0_out, mul1_out, mul2_out;	
	
	ctrl1			ctrl1			(.reset(reset), .preq(preq), .nreq(nreq), .lclk(lclk1));
	wd_st1_y		wd_st1_y		(.in(lclk1), .out(wd_st1_y_out));
	wd_st1_u		wd_st1_u		(.in(lclk1), .out(wd_st1_u_out));
	wd_st1_dx	wd_st1_dx	(.in(lclk1), .out(wd_st1_dx_out));
	wd_add0_reg	wd_add0_reg	(.in(lclk1), .out(wd_add0_reg_out));
	wd_mul0_reg	wd_mul0_reg	(.in(lclk1), .out(wd_mul0_reg_out));
	wd_mul1_reg	wd_mul1_reg	(.in(lclk1), .out(wd_mul1_reg_out));	
	wd_mul2_reg	wd_mul2_reg	(.in(lclk1), .out(wd_mul2_reg_out));
	
	add32     	add0 			(.a(in1), .b(in4), .out(add0_out));
	mult32_32 	mul0 			(.a(in1), .b(3), .out(mul0_out));
	mult32_32 	mul1 			(.a(in3), .b(in4), .out(mul1_out));
	mult32_32 	mul2	 		(.a(in2), .b(3), .out(mul2_out));
	dff32a 		st1_y    	(.in(in2), .reset(reset), .clock(wd_st1_y_out), .out(out1));
	dff32a 		st1_u    	(.in(in3), .reset(reset), .clock(wd_st1_u_out), .out(out2));
	dff32a 		st1_dx   	(.in(in4), .reset(reset), .clock(wd_st1_dx_out), .out(out3));
	dff32a 		add0_reg 	(.in(add0_out), .reset(reset), .clock(wd_add0_reg_out), .out(out4));
	dff32a 		mul0_reg 	(.in(mul0_out), .reset(reset), .clock(wd_mul0_reg_out), .out(out5));
	dff32a 		mul1_reg 	(.in(mul1_out), .reset(reset), .clock(wd_mul1_reg_out), .out(out6));
	dff32a 		mul2_reg 	(.in(mul2_out), .reset(reset), .clock(wd_mul2_reg_out), .out(out7));

endmodule
