module stage2 (reset, preq, nreq, in1, in2, in3, in4, in5, in6, in7, out1, out2, out3, out4, out5);
	input reset;
	input preq;
	output nreq;
	input [31:0] in1, in2, in3, in4, in5, in6, in7;
	output [31:0] out1, out2, out3, out4, out5;
	
	wire lclk2;
	wire wd_st2_u_out;
	wire wd_add1_reg_out;
	wire wd_mul3_reg_out;
	wire wd_mul4_reg_out;
	wire wd_st2_add0_reg_out;
	
	wire [31:0] add1_out, mul3_out, mul4_out;

	ctrl2					ctrl2				(.reset(reset), .preq(preq), .nreq(nreq), .lclk(lclk2));
	wd_st2_u				wd_st2_u			(.in(lclk2), .out(wd_st2_u_out));
	wd_add1_reg			wd_add1_reg		(.in(lclk2), .out(wd_add1_reg_out));
	wd_mul3_reg			wd_mul3_reg		(.in(lclk2), .out(wd_mul3_reg_out));
	wd_mul4_reg 		wd_mul4_reg		(.in(lclk2), .out(wd_mul4_reg_out));
	wd_st2_add0_reg	wd_st2_add0_reg(.in(lclk2), .out(wd_st2_add0_reg_out));
	
	add32     			add1 				(.a(in1), .b(in6), .out(add1_out));
	mult32_32 			mul3 				(.a(in5), .b(in6), .out(mul3_out));
	mult32_32 			mul4				(.a(in7), .b(in3), .out(mul4_out));
	dff32a				st2_u			   (.in(in2), .reset(reset), .clock(wd_st2_u_out), .out(out1));
	dff32a 				add1_reg 		(.in(add1_out), .reset(reset), .clock(wd_add1_reg_out), .out(out2));
	dff32a 				mul3_reg 		(.in(mul3_out), .reset(reset), .clock(wd_mul3_reg_out), .out(out3));
	dff32a 				mul4_reg 		(.in(mul4_out), .reset(reset), .clock(wd_mul4_reg_out), .out(out4));
	dff32a 				st2_add0_reg 	(.in(in4), .reset(reset), .clock(wd_st2_add0_reg_out), .out(out5));

endmodule
