module stage3 (reset, preq, nreq, in1, in2, in3, in4, in5, out1, out2, out3, out4);
	input reset;
	input preq;
	output nreq;
	input [31:0] in1, in2, in3, in4, in5;
	output [31:0] out1, out2, out3, out4;
	
	wire lclk3;
	wire wd_sub0_reg_out;
	wire wd_st3_mul4_reg_out;
	wire wd_st3_add0_reg_out;
	wire wd_st3_add1_reg_out;
	wire [31:0] sub0_out;
	
	ctrl3					ctrl3				(.reset(reset), .preq(preq), .nreq(nreq), .lclk(lclk3));
	wd_sub0_reg			wd_sub0_reg		(.in(lclk3), .out(wd_sub0_reg_out));
	wd_st3_mul4_reg	wd_st3_mul4_reg(.in(lclk3), .out(wd_st3_mul4_reg_out));
	wd_st3_add0_reg	wd_st3_add0_reg(.in(lclk3), .out(wd_st3_add0_reg_out));
	wd_st3_add1_reg	wd_st3_add1_reg(.in(lclk3), .out(wd_st3_add1_reg_out));	
	
	sub32					sub0     		(.a(in1), .b(in3), .out(sub0_out));
	dff32a				sub0_reg			(.in(sub0_out), .reset(reset), .clock(wd_sub0_reg_out), .out(out1));
	dff32a 				st3_mul4_reg	(.in(in4), .reset(reset), .clock(wd_st3_mul4_reg_out), .out(out2));
	dff32a 				st3_add0_reg 	(.in(in5), .reset(reset), .clock(wd_st3_add0_reg_out), .out(out3));	
	dff32a 				st3_add1_reg 	(.in(in2), .reset(reset), .clock(wd_st3_add1_reg_out), .out(out4));
	
endmodule
