module stage4	(reset, preq, nreq, in1, in2, in3, in4, out1, out2, out3);
	input reset;
	input preq;
	output nreq;
	input [31:0] in1, in2, in3, in4;
	output [31:0] out1, out2, out3;
	
	wire lclk4;
	wire wd_sub1_reg_out;
	wire wd_st4_add0_reg_out;
	wire wd_st4_add1_reg_out;	
	wire [31:0] sub1_out;
	
	ctrl4					ctrl4				(.reset(reset), .preq(preq), .nreq(nreq), .lclk(lclk4));
	wd_sub1_reg			wd_sub1_reg		(.in(lclk4), .out(wd_sub1_reg_out));
	wd_st4_add0_reg	wd_st4_add0_reg(.in(lclk4), .out(wd_st4_add0_reg_out));
	wd_st4_add1_reg	wd_st4_add1_reg(.in(lclk4), .out(wd_st4_add1_reg_out));		

	sub32					sub1    			(.a(in1), .b(in2), .out(sub1_out));	
	dff32a 				sub1_reg			(.in(sub1_out), .reset(reset), .clock(wd_sub1_reg_out), .out(out1));
	dff32a 				st4_add0_reg	(.in(in3), .reset(reset), .clock(wd_st4_add0_reg_out), .out(out2));
	dff32a 				st4_add1_reg	(.in(in4), .reset(reset), .clock(wd_st4_add1_reg_out), .out(out3));	

endmodule
